#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

int
main(argc, argv)
	int	argc;
	char *	argv[];
{
  int			sd;
  int			n;
  char			recvline[256];
  struct sockaddr_in	saddr;

  if (argc != 2) {
    fprintf(stderr, "usage: %s <IPaddress>\n", argv[0]);
    exit(1);
  }

  sd = socket(AF_INET, SOCK_STREAM, 0);
  if (sd == -1) {
    perror("socket");
    exit(1);
  }

  bzero(&saddr, sizeof(saddr));
  saddr.sin_family	= AF_INET;
  saddr.sin_port	= htons(10013);
  if (inet_pton(AF_INET, argv[1], &saddr.sin_addr) <= 0) {
    fprintf(stderr, "inet_pton error for %s\n", argv[1]);
    exit(1);
  }

  if (connect(sd, (struct sockaddr *)&saddr, sizeof(saddr)) == -1) {
    perror("connect");
    exit(1);
  }
  while ((n = read(sd, recvline, sizeof(recvline))) > 0) {
    recvline[n] = '\0';
    if (fputs(recvline, stdout) == EOF) {
      fputs("fputs error\n", stderr);
      exit(1);
    }
  }
  if (n < 0) {
    fputs("read error\n", stderr);
    exit(1);
  }
  close(sd);

  return 0;
}
