#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <time.h>
#include <errno.h>
#include "wt.h"

int
main(argc, argv)
	int	argc;
	char *	argv[];
{
  wt_netfd_t *	nsd;

  if (wt_init(WT_VP_SS_TINY) == -1) {
    perror("wt_init");
    exit(1);
  }

  if (argc == 2) {
    nsd = wt_netfd_tcp_server(NULL, argv[1], 0);
  }
  else if (argc == 3) {
    nsd = wt_netfd_tcp_server(argv[1], argv[2], 0);
  }
  else {
    fprintf(stderr, "usage: %s [<host>] <service or port>\n", argv[0]);
    exit(1);
  }
  if (nsd == NULL) {
    perror("wt_initport");
    exit(1);
  }

  for (;;) {
    struct sockaddr 	cliaddr;
    socklen_t		len	= wt_netfd_socklen(nsd);
    wt_netfd_t *	nfd	= wt_netfd_accept(nsd, &cliaddr, &len, WT_UTIME_NO_TIMEOUT);
    time_t		ticks	= time(NULL);
    char		buf[256];

    fprintf(stderr, "errno = %d\tlen = %d\n", errno, len);
    fprintf(stderr, "connection from %s\n", wt_sock_ntop(&cliaddr, true));
    memset(buf, 0, sizeof(buf));
    snprintf(buf, sizeof(buf), "%.24s\r\n", ctime(&ticks));
    wt_netfd_writen(nfd, buf, strlen(buf), WT_UTIME_NO_TIMEOUT);
    wt_netfd_close(nfd);
  }

  return 0;
}
