#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <time.h>
#include "wt.h"

static void	send_mesg(wt_netfd_t *);
static void	send_text(wt_netfd_t *, const char *);

int
main(argc, argv)
	int	argc;
	char *	argv[];
{
  const char	mesg1[] = "Hello TekeP World!\n";
  const char	mesg2[] = "Good Morning!\n";
  wt_netfd_t *	nsd;

  if (wt_init(WT_VP_SS_SMALL) == -1) {
    perror("wt_init");
    exit(1);
  }

  if (argc == 2) {
    nsd = wt_netfd_tcp_client(NULL, argv[1]);
  }
  else if (argc == 3) {
    nsd = wt_netfd_tcp_client(argv[1], argv[2]);
  }
  else {
    fprintf(stderr, "usage: %s [<host>] <service or port>\n", argv[0]);
    exit(1);
  }
  if (nsd == NULL) {
    perror("wt_initport");
    exit(1);
  }

#if	0
  send_mesg(nsd);
#else
  send_text(nsd, mesg1);
  send_text(nsd, mesg2);
#endif
  wt_netfd_close(nsd);

  return 0;
}

static void
send_mesg(nfd)
	wt_netfd_t *	nfd;
{
  const char	mesg1[] = "Hello World!\n";
  const char	mesg2[] = "Good Night! ...zzZ\n";
  char		buf[BUFSIZ];

  fprintf(stderr, "DEBUG: Echo: communication descriptor #%d\n", nfd->osfd);
  wt_netfd_writen(nfd, mesg1, strlen(mesg1), WT_UTIME_NO_TIMEOUT);
  memset(buf, 0, sizeof(buf));
  wt_netfd_readline(nfd, buf, sizeof(buf), WT_UTIME_NO_TIMEOUT);
  fputs(buf, stdout);

  wt_netfd_writen(nfd, mesg2, strlen(mesg2), WT_UTIME_NO_TIMEOUT);
  memset(buf, 0, sizeof(buf));
  wt_netfd_readline(nfd, buf, sizeof(buf), WT_UTIME_NO_TIMEOUT);
  fputs(buf, stdout);
}

static void
send_text(nfd, mesg)
	wt_netfd_t *	nfd;
	const char *	mesg;
{
  char	buf[BUFSIZ];

  fprintf(stderr, "DEBUG: Echo: communication descriptor #%d\n", nfd->osfd);
  wt_netfd_writen(nfd, mesg, strlen(mesg), WT_UTIME_NO_TIMEOUT);
  memset(buf, 0, sizeof(buf));
  wt_netfd_readline(nfd, buf, sizeof(buf), WT_UTIME_NO_TIMEOUT);
  fputs(buf, stdout);
}

