#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <time.h>
#include <errno.h>
#include "wt.h"

static void	echo(wt_netfd_t *);

int
main(argc, argv)
	int	argc;
	char *	argv[];
{
  wt_netfd_t *	nsd;

  if (wt_init(WT_VP_SS_TINY) == -1) {
    perror("wt_init");
    exit(1);
  }

  if (argc == 2) {
    nsd = wt_netfd_tcp_server(NULL, argv[1], 0);
  }
  else if (argc == 3) {
    nsd = wt_netfd_tcp_server(argv[1], argv[2], 0);
  }
  else {
    fprintf(stderr, "usage: %s [<host>] <service or port>\n", argv[0]);
    exit(1);
  }
  if (nsd == NULL) {
    perror("wt_initport");
    exit(1);
  }

  for (;;) {
    struct sockaddr 	cliaddr;
    socklen_t		len	= wt_netfd_socklen(nsd);
    wt_netfd_t *	nfd	= wt_netfd_accept(nsd, &cliaddr, &len, WT_UTIME_NO_TIMEOUT);
    wt_thread_t		thd;
    wt_thread_attr_t	attr = wt_thread_attr_defaults;
    
    attr.name = "echo";
    if (wt_thread_create(&thd, &attr, (void *)&echo, nfd) == 0) {
      fprintf(stderr, "errno = %d\tlen = %d\n", errno, len);
      fprintf(stderr, "connection from %s\n", wt_sock_ntop(&cliaddr, true));
    }
  }

  return 0;
}

static void
echo(nfd)
	wt_netfd_t *	nfd;
{
  fprintf(stderr, "DEBUG: Echo: communication descriptor #%d\n", nfd->osfd);
  for (;;) {
    char	buf[BUFSIZ];
    ssize_t	n;

    memset(buf, 0, sizeof(buf));
#if	1
    n = wt_netfd_readline(nfd, buf, sizeof(buf), WT_UTIME_NO_TIMEOUT);
#else
    n = wt_netfd_read(nfd, buf, sizeof(buf), WT_UTIME_NO_TIMEOUT);
#endif
    if (n == 0) {
      wt_netfd_close(nfd);
      wt_thread_exit(0);
    }
    fprintf(stderr, "DEBUG: Echo [%s]\n", buf);
    wt_netfd_writen(nfd, buf, strlen(buf), WT_UTIME_NO_TIMEOUT);
  }
}

