#include <stdio.h>
#include <string.h>
#include "wt-ssl.h"

int
main()
{
  wt_netfd_t *	nfd;
  char		buf[BUFSIZ];
  ssize_t	n;

  if (wt_init(WT_VP_SS_MEDIUM) == -1) {
    perror("wt_init");
    exit(1);
  }

  nfd = wt_netfd_ssl_tcp_client("127.0.0.1", "8443");
  if (nfd == NULL) {
    perror("wt_netfd_ssl_tcp_client");
    exit(1);
  }

#define	MSG	"Hello, World!"
  n = wt_netfd_ssl_write(nfd, MSG, strlen(MSG), WT_UTIME_NO_TIMEOUT);
  n = wt_netfd_ssl_read(nfd, buf, sizeof(buf) - 1, WT_UTIME_NO_TIMEOUT);
  buf[n] = '\0';
  fprintf(stdout, "Got %d chars:'%s'\n", n, buf);

  wt_netfd_ssl_close(nfd);

  return 0;
}

