#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "wt-ssl.h"

int
main()
{
  wt_netfd_t *	nsd;

  if (wt_init(WT_VP_SS_MEDIUM) == -1) {
    perror("wt_init");
    exit(1);
  }

  nsd = wt_netfd_ssl_tcp_server(NULL, "8443", 10, "server.crt", "server.key",
				NULL);
  if (nsd == NULL) {
    perror("wt_netfd_ssl_tcp_server");
    exit(1);
  }

  for (;;) {
    struct sockaddr	cliaddr;
    socklen_t		len = wt_netfd_socklen(nsd);
    wt_netfd_t *	nfd = wt_netfd_ssl_accept(nsd, &cliaddr, &len, WT_UTIME_NO_TIMEOUT);
    char		buf[BUFSIZ];
    ssize_t		n;

    if (nfd == NULL) {
      fprintf(stderr, "errno: %d\n", errno);
      continue;
    }
    n = wt_netfd_ssl_read(nfd, buf, sizeof(buf) - 1, WT_UTIME_NO_TIMEOUT);
    buf[n] = '\0';
    fprintf(stdout, "Got %d chars:'%s'\n", n, buf);

#define	MSG	"Hello, World!"
    n = wt_netfd_ssl_write(nfd, MSG, strlen(MSG), WT_UTIME_NO_TIMEOUT);

    wt_netfd_ssl_close(nfd);
  }

  return 0;
}

