/*
 *	MD5.H - header file for MD5C.C
 */

/*
 * Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991.
 * All rights reserved.
 *
 * License to copy and use this software is granted provided that it
 * is identified as the "RSA Data Security, Inc. MD5 Message-Digest
 * Algorithm" in all material mentioning or referencing this software
 * or this function.
 *
 * License is also granted to make and use derivative works provided
 * that such works are identified as "derived from the RSA Data
 * Security, Inc. MD5 Message-Digest Algorithm" in all material
 * mentioning or referencing the derived work.
 * 
 * RSA Data Security, Inc. makes no representations concerning either
 * the merchantability of this software or the suitability of this
 * software for any particular purpose. It is provided "as is"
 * without express or implied warranty of any kind.
 * 
 * These notices must be retained in any copies of any part of this
 * documentation and/or software.
 */

#ifndef	_MD5_H_
#define	_MD5_H_

/* POINTER defines a generic pointer type */
typedef unsigned char *		POINTER;

/* UINT2 defines a two byte word */
typedef unsigned short int	UINT2;

/* UINT4 defines a four byte word */
typedef unsigned long int	UINT4;

/* MD5 context. */
typedef struct {
  UINT4		state[4];				/* state (ABCD) */
  UINT4		count[2];	/* number of bits, modulo 2^64 (lsb first) */
  unsigned char	buffer[64];				/* input buffer */
} MD5_CTX;

#define	MD5_DIGEST_LENGTH	16

extern void	MD5Init(MD5_CTX *);
extern void	MD5Update(MD5_CTX *, unsigned char *, unsigned int);
extern void	MD5Final(unsigned char [MD5_DIGEST_LENGTH], MD5_CTX *);
/* The following procedures appended on Sat, Oct  9 2004 */
extern char *	MD5End(MD5_CTX *, char *);
extern char *	MD5File(const char *, char *);
extern char *	MD5Data(const unsigned char *, unsigned int, char *);

#endif	/* _MD5_H_ */
