/*
 * Copyright (c) 2005 Kouichi ABE (WALL), All rights reserved.
 * $Id: sqlite_log.sql,v 1.3 2007/03/30 18:24:22 kouichi Exp $
 */
BEGIN TRANSACTION;

CREATE TABLE access_log (
  hostname	TEXT NOT NULL,	-- virtual server name
  timestamp	TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
  ipaddr	INET NOT NULL,
  forwarded_for	TEXT,		-- access through a proxy
  ident_name	TEXT,		-- identd
  auth_name	TEXT,		-- http authentication
  method	TEXT,		-- http request method
  request_uri	TEXT,		-- http request uri
  protocol	TEXT,		-- http protocol version
  status	INTEGER,	-- response status code
  length	INTEGER,	-- response content size
  phrase	TEXT,		-- error phrase
  referer	TEXT,
  user_agent	TEXT,
  uptime	NUMERIC,	-- second
  PRIMARY KEY (hostname,timestamp,ipaddr,request_uri,uptime)
);
CREATE INDEX access_log_idx01 ON access_log(hostname);
CREATE INDEX access_log_idx02 ON access_log(timestamp);
CREATE INDEX access_log_idx03 ON access_log(ipaddr);
CREATE INDEX access_log_idx04 ON access_log(method);
CREATE INDEX access_log_idx05 ON access_log(request_uri);
CREATE INDEX access_log_idx06 ON access_log(protocol);
CREATE INDEX access_log_idx07 ON access_log(status);
CREATE INDEX access_log_idx08 ON access_log(referer);
CREATE INDEX access_log_idx09 ON access_log(user_agent);
CREATE INDEX access_log_idx10 ON access_log(auth_name);

COMMIT;
